package cn.iocoder.yudao.module.mes.service.zjtype;

import java.util.*;
import javax.validation.*;

import cn.iocoder.yudao.module.iot.dal.dataobject.deviceattributetype.DeviceAttributeTypeDO;
import cn.iocoder.yudao.module.mes.controller.admin.zjitem.vo.ZjItemPageReqVO;
import cn.iocoder.yudao.module.mes.controller.admin.zjtype.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.zjitem.ZjItemDO;
import cn.iocoder.yudao.module.mes.dal.dataobject.zjtype.ZjTypeDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;

import static cn.iocoder.yudao.framework.common.util.collection.CollectionUtils.convertMap;

/**
 * 质量管理-检验类型 Service 接口
 *
 * @author 内蒙必硕
 */
public interface ZjTypeService {

    /**
     * 创建质量管理-检验类型
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createZjType(@Valid ZjTypeSaveReqVO createReqVO);

    /**
     * 更新质量管理-检验类型
     *
     * @param updateReqVO 更新信息
     */
    void updateZjType(@Valid ZjTypeSaveReqVO updateReqVO);

    /**
     * 删除质量管理-检验类型
     *
     * @param id 编号
     */
    void deleteZjType(Long id);

    /**
     * 获得质量管理-检验类型
     *
     * @param id 编号
     * @return 质量管理-检验类型
     */
    ZjTypeDO getZjType(Long id);

    /**
     * 获得质量管理-检验类型分页
     *
     * @param pageReqVO 分页查询
     * @return 质量管理-检验类型分页
     */
    PageResult<ZjTypeDO> getZjTypePage(ZjTypePageReqVO pageReqVO);

    /**
     * 获得质量管理-检验类型列表
     *
     * @return 检验类型列表
     */
    List<ZjTypeDO> getZjTypeList();


    List<ZjTypeDO> getZjTypeVOList(Collection<Long> ids);
    default Map<Long, ZjTypeDO> getZjTypeVOMap(Collection<Long> ids) {
        if(ids.isEmpty())return new HashMap<>();
        return convertMap(getZjTypeVOList(ids), ZjTypeDO::getId);
    }
}